---------------------
RS3/FlatSat Software
---------------------

The RS3/FlatSat includes a suite of Pumpkin-provided software to discover, generate and inject telemetry sets into SupMCU modules named ``PuTDIG-CLI`` and ``PuTDIG``.

.. note:: Generation and injection of telemetry is **only** supported by Pumpkin QSM modules inside of the RS3/FlatSat; FM/EM SUPERNOVA Bus modules **DO NOT** support telemetry generation/injection.

.. _putdig-sw:

RS3/FlatSat CLI Software
========================

The KubOS image for the RS3/FlatSat includes the following set of ``PuTDIG`` CLI programs to augment the operation of KubOS and facilitate testing from scripted environments:

* **pumqry** - A query application to discover telemetry present on SupMCU modules. Note modules queried **DO NOT** have to be QSM modules; they can be EM/FM modules as well!
* **pumgen** - A generation application to generate a telemetry set to inject into QSM modules inside of the RS3
* **puminj** - An injection application to inject a generated telemetry set into QSM modules present inside of the RS3

All CLI applications are meant to be used from a console environment as well as part of test scripts.
Their output, by default, is directed to ``stdout`` and meant to be directable/pipable to other UNIX commands.

.. note:: All examples below assume the user is connected to the RS3/FlatSat unit via SSH or similar connection to execute commands on the Linux command-line in KubOS

.. _pumqry:

``pumqry`` Application
**********************

The ``pumqry`` application is used to:

* See the available SupMCU modules on the CSK I2C bus
* Discover all of the telemetry on each of the SupMCU modules
* Export all of the telemetry/default values to a JSON file

To list all of the telemetry availble on the RS3 bus in a formatted JSON output to ``stdout`` use the following command from a shell connected to the BBB on the RS3 ::

    $ pumqry -t kubos -p 1 -d

To list the I2C address of every SupMCU module present on the I2C bus inside of the RS3/FlatSat ::

    $ pumqry -t kubos -p 1 -l

More examples and information about `pumqry can be found here <https://pumpkinspace.github.io/PuTDIG-CLI/pages/pumqry/pumqry.html>`_

.. _pumgen:

``pumgen`` Application
**********************

The ``pumgen`` application is used to:

* Generate telemetry sets from the output of ``pumqry``
* Edit existing telemetry sets to be injected into QSM modules
* Provide a user-friendly interactive mode to edit telemetry sets

To enter an interactive mode from an existing telemetry set/definition (named ``telemetry.json``), run ::

    $ pumgen.py -d telemetry.json -i

This will enter an interactive mode similar to ::

    Welcome to pumgen, please select a module to set telemetry for:

    1.  BIM
    2.  PIM
    3.  DCPS
    4.  RHM
    5.  DASA

    B. Back
    Q. Quit and save
    Ctrl-C to quit without saving

    Choice:

To edit a single telemetry value in ``telemetry.json`` named ``PIM Status Register`` on the ``PIM`` module to ``0x55`` enter ::

    $ pumgen.py -d telemetry.json -f telemetry.json -q -m PIM -t "PIM Status Register" -v 0x55

More examples and information about `pumgen can be found here <https://pumpkinspace.github.io/PuTDIG-CLI/pages/pumgen/pumgen.html>`_

.. _puminj:

``puminj`` Application
**********************

The ``puminj`` application is used to:

* Inject telemetry sets generated by ``pumgen`` into QSM modules
* Provide injection via I2C or Serial interfaces

.. note:: Serial injection is only provided via external host; serial injection **is not** supported directly inside of KubOS from the BBB.

To inject a telemetry set named ``telemetry.json`` into the bus using KubOS, execute ::

    $ puminj -t kubos -p 1 -g telemetry.json

To inject a telemetry set over serial into COM1-4 into the bus, execute ::

    $ puminj -t serial -p COM1,COM2,COM3,COM4 -g telemetry.json

More examples and information about `puninj can be found here <https://pumpkinspace.github.io/PuTDIG-CLI/pages/puminj/puminj.html>`_.

``pumpkin-supmcu-service``
==========================

The ``pumpkin-supmcu-service`` in KubOS is meant to be the main interface to use while interacting with SupMCU modules via FSW. This supports:

* Querying Telemetry and returning results via GraphQL queries
* Sending SCPI Commands via GraphQL mutations
* Listing available modules/telemetry/commands across all modules in the RS3/FlatSat
* Be reconfigurable from ``pumqry`` bus discovery

In order to use the ``pumpkin-supmcu-service`` see the documentation `here <https://gitlab.com/pumpkin-space-systems/public/kubos/-/tree/master/services/pumpkin-mcu-service>`_.

RS3/FlatSat Web Software
========================

There is currently one Pumpkin-provided application to encapsulate the CLI applications into a web-based interface called ``PuTDIG``.
This software handles:

* Discovery/Loading of telemetry present inside of the RS3
* Editing telemetry values discovered on the RS3/QSM modules
* Injecting the edited telemetry values into the RS3 unit

.. warning::
    This software is still under active development and is expected to stabilize and improve over time.
    Keep the KubOS image up to date to receive the latest features.
    It is recommended to use the CLI software until this feature is stabilized.

.. image:: /img/putdig.png

To run ``PuTDIG`` simply SSH into the RS3 unit and execute ::

    $ putdig

Once running, connect to the RS3 unit at port ``8080`` inside of Firefox or similar web-browser to use the PuTDIG software.

See the `PuTDIG Documentation <https://pumpkinspace.github.io/PuTDIG/index.html>`_ for usage.
